CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

  duty_pin      = 24
  sign_pin      = 25

  sine          = $e000

VAR

  long  waveform[128]
  byte  cogno

OBJ

  spkr : "L6205_spkr"

PUB test_ | amplitude, i, phase, t, f

  dira[0]~~

  repeat i from 0 to 63
    waveform[i] := sin(i << 7) * 16000
  amplitude~
  spkr.start(duty_pin, sign_pin, @amplitude)
  f := clkfreq / 25000
  t := cnt
  repeat
    waitcnt(t += f)
    !outa[0]
    amplitude := waveform[i := (i + 1) & 63]

PRI sin(x) : value

  '' Sine of the angle x: 0 to 360 degrees = $0000 to $2000

  if (x & $fff == $800)
    value := $1_0000
  elseif (x & $800)
    value := word[sine][-x & $7ff]
  else
    value := word[sine][x & $7ff]
  if (x & $1000)
    value := -value